You can customize the properties of autoShapes using the Shape API:
text: Gets or sets the text of the shape.
style: Gets or sets the style of the shape.
You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
initEvent(spread);
};
var lineCapStyle = {
flat: 2,
square: 1,
round: 0
};
var lineJoinStyle = {
round: 0,
miter: 1,
bevel: 2
};
var lineDashStyle = {
solid: 0,
squareDot: 1,
dash: 2,
longDash: 3,
dashDot: 4,
longDashDot: 5,
longDashDotDot: 6,
sysDash: 7,
sysDot: 8,
sysDashDot: 9,
dashDotDot: 10
};
var activeShape;
function fillShapeTypeList(type, dom) {
var names = [];
for (var name in type) {
if(name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({name: name, value: type[name]});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
var html = "";
names.forEach(function (item) {
html += '<option value="' + item.value + '">' + item.name + '</option>';
});
dom.innerHTML= html;
}
function getActiveConnectorShape(sheet) {
return sheet.shapes.all().filter(function(sp){
return sp.isSelected() && sp instanceof GC.Spread.Sheets.Shapes.ConnectorShape;
});
}
function initSpread(spread) {
setBorderPropVisibility("none");
fillShapeTypeList(lineDashStyle, _getElementById("borderLineStyle"));
fillShapeTypeList(lineCapStyle, _getElementById("borderCapLineStyle"));
fillShapeTypeList(lineJoinStyle, _getElementById("borderJoinLineStyle"));
let oval = spread.getActiveSheet().shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 40, 20, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#FFFFFF";
oval.style(ovalStyle);
var rectangle = spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 230, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#FFFFFF";
rectangle.style(rectangleStyle);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 250, 20, 400, 150);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 250, 250, 400, 350);
}
function setBorderPropVisibility(display) {
var borderProp = _getElementById("borderProp");
borderProp.style.display = display;
}
function initEvent(spread) {
var spreadNS = GC.Spread.Sheets;
var sheet = spread.getActiveSheet();
sheet.bind(spreadNS.Events.ShapeSelectionChanged, function () {
var selectedShape = sheet.shapes.all().filter(function(sp){
return sp.isSelected();
});
var isShapeSelected = false, isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach(function (shape) {
if (!isShapeSelected && shape instanceof spreadNS.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof spreadNS.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
setBorderPropVisibility("block");
} else {
setBorderPropVisibility("none");
}
});
_getElementById("borderColorActionBtn").addEventListener('click', function() {
_handleShapeBorderAction(spread, 'color', _getElementById("borderColorStyle"));
});
_getElementById("borderTransparencyActionBtn").addEventListener('click', function() {
_handleShapeBorderAction(spread, 'transparency', _getElementById("borderTransparencyStyle"));
});
_getElementById("borderWidthActionBtn").addEventListener('click', function() {
_handleShapeBorderAction(spread, 'width', _getElementById("borderWidthStyle"));
});
_getElementById("borderLineStyleActionBtn").addEventListener('click', function() {
_handleShapeBorderAction(spread, 'lineStyle', _getElementById("borderLineStyle"));
});
_getElementById("borderCapLineActionBtn").addEventListener('click', function() {
_handleShapeBorderAction(spread, 'capType', _getElementById("borderCapLineStyle"));
});
_getElementById("borderJoinLineActionBtn").addEventListener('click', function() {
_handleShapeBorderAction(spread, 'joinType', _getElementById("borderJoinLineStyle"));
});
}
function _handleShapeBorderAction(spread, action, valueDom) {
var sheet = spread.getActiveSheet();
activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape) {
activeShape.forEach(function (shape) {
var shapeStyle = shape.style();
shapeStyle.line[action] = valueDom.value;
shape.style(shapeStyle);
});
sheet.repaint();
}
}
function _getElementById(id){
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<div class="option-row">
Try selecting a shape and change the border properties to see the effect: </div>
<div id="divideLine" class="divide-line"></div>
<div id="borderProp" class="option-row">
<label>Border Color: </label>
<input id="borderColorStyle" data-attr="color" type="color" value="#00A2E8"/>
<input type="button" id='borderColorActionBtn' value="Set"/>
<label>Border Transparency: </label>
<input id="borderTransparencyStyle" data-attr="transparency" type="text" value="0.5"/>
<input type="button" id='borderTransparencyActionBtn' value="Set"/>
<label>Border Width: </label>
<input id="borderWidthStyle" data-attr="width" type="number" value="1"/>
<input type="button" id='borderWidthActionBtn' value="Set"/>
<label>Border Line Style: </label>
<select id="borderLineStyle" data-attr="lineStyle"></select>
<input type="button" id='borderLineStyleActionBtn' value="Set"/>
<label>Border Cap Line Style: </label>
<select id="borderCapLineStyle" data-attr="capType"></select>
<input type="button" id='borderCapLineActionBtn' value="Set"/>
<label>Border Join Line Style: </label>
<select id="borderJoinLineStyle" data-attr="joinType"></select>
<input type="button" id='borderJoinLineActionBtn' value="Set"/>
</div>
</div>
</div></body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

You can customize the properties of autoShapes using the Shape API:
text: Gets or sets the text of the shape.
style: Gets or sets the style of the shape.
You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import { SpreadSheets } from '@mescius/spread-sheets-react';
import Panel from './panel.jsx';
let spread = null;
export function AppFunc() {
const [showBorderPanel, setShowBorderPanel] = React.useState(false);
const updateShapeBorderStyle = (action, value) => {
let sheet = spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function (shape) {
let shapeStyle = shape.style();
shapeStyle.line[action] = value;
shape.style(shapeStyle);
});
sheet.repaint();
}
}
const setBorderPropVisibility = (isShow) => {
setShowBorderPanel(isShow);
}
const initSpread = (currSpread) => {
spread = currSpread;
let oval = spread.getActiveSheet().shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 40, 20, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#FFFFFF";
oval.style(ovalStyle);
var rectangle = spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 230, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#FFFFFF";
rectangle.style(rectangleStyle);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 250, 20, 400, 150);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 250, 250, 400, 350);
bindSpreadEvent();
}
const bindSpreadEvent = () => {
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let sheet = spread.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
setBorderPropVisibility(true);
} else {
setBorderPropVisibility(false);
}
})
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
showBorderPanel={showBorderPanel}
updateShapeBorderStyle={(action, value) => { updateShapeBorderStyle(action, value) }}>
</Panel>
</div>);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import { SpreadSheets } from '@mescius/spread-sheets-react';
import Panel from './panel.jsx';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.autoGenerateColumns = false;
this.state = {
showBorderPanel: false
}
}
render() {
const {
showBorderPanel
} = this.state;
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<Panel
showBorderPanel={showBorderPanel}
updateShapeBorderStyle={(action, value) => { this.updateShapeBorderStyle(action, value) }}>
</Panel>
</div>);
}
updateShapeBorderStyle(action, value) {
let sheet = this.spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function (shape) {
let shapeStyle = shape.style();
shapeStyle.line[action] = value;
shape.style(shapeStyle);
});
sheet.repaint();
}
}
setBorderPropVisibility(isShow) {
this.setState({ showBorderPanel: isShow });
}
initSpread(spread) {
this.spread = spread;
let oval = spread.getActiveSheet().shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 40, 20, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#FFFFFF";
oval.style(ovalStyle);
var rectangle = spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 230, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#FFFFFF";
rectangle.style(rectangleStyle);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 250, 20, 400, 150);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 250, 250, 400, 350);
this.bindSpreadEvent();
}
bindSpreadEvent() {
let spread = this.spread,
self = this;
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let sheet = spread.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
self.setBorderPropVisibility(true);
} else {
self.setBorderPropVisibility(false);
}
})
}
}
import * as React from 'react';
import "@mescius/spread-sheets-shapes"
export default function Panel(props) {
const lineCapStyle = {
flat: 2,
square: 1,
round: 0
};
const lineJoinStyle = {
round: 0,
miter: 1,
bevel: 2
};
const lineDashStyle = {
solid: 0,
squareDot: 1,
dash: 2,
longDash: 3,
dashDot: 4,
longDashDot: 5,
longDashDotDot: 6,
sysDash: 7,
sysDot: 8,
sysDashDot: 9,
dashDotDot: 10
};
const {
updateShapeBorderStyle,
showBorderPanel
} = props;
const [borderOption, setBorderOption] = React.useState({
borderColor: "#00A2E8",
borderTransparency: 0.5,
borderWidth: 1,
borderLineStyle: 2,
borderCapType: 2,
borderJoinType: 2,
lineCapStyleList: getEnumList(lineCapStyle),
lineJoinStyleList: getEnumList(lineJoinStyle),
lineDashStyleList: getEnumList(lineDashStyle)
});
return (<div class="options-container">
<div class="option-row">
Try selecting a shape and change the border properties to see the effect:
</div>
<div id="divideLine" class="divide-line"></div>
{showBorderPanel &&
<div class="option-row">
<label>Border Color: </label>
<input value={borderOption.borderColor} type="color" onChange={(event) => { setBorderOption({ ...borderOption, borderColor: event.target.value }); }} />
<input type="button" onClick={() => { updateShapeBorderStyle('color', borderOption.borderColor) }} value="Set" />
<label>Border Transparency: </label>
<input value={borderOption.borderTransparency} type="text" onChange={(event) => { setBorderOption({ ...borderOption, borderTransparency: event.target.value }); }} />
<input type="button" onClick={() => { updateShapeBorderStyle('transparency', borderOption.borderTransparency) }} value="Set" />
<label>Border Width: </label>
<input value={borderOption.borderWidth} type="number" onChange={(event) => { setBorderOption({ ...borderOption, borderWidth: event.target.value }); }} />
<input type="button" onClick={() => { updateShapeBorderStyle('width', borderOption.borderWidth) }} value="Set" />
<label>Border Line Style: </label>
<select value={borderOption.borderLineStyle} onChange={(event) => { setBorderOption({ ...borderOption, borderLineStyle: event.target.value }); }}>
{borderOption.lineDashStyleList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select>
<input type="button" onClick={() => { updateShapeBorderStyle('lineStyle', borderOption.borderLineStyle) }} value="Set" />
<label>Border Cap Line Style: </label>
<select value={borderOption.borderCapType} onChange={(event) => { setBorderOption({ ...borderOption, borderCapType: event.target.value }); }}>
{borderOption.lineCapStyleList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select>
<input type="button" onClick={() => { updateShapeBorderStyle('capType', borderOption.borderCapType) }} value="Set" />
<label>Border Join Line Style: </label>
<select value={borderOption.borderJoinType} onChange={(event) => { setBorderOption({ ...borderOption, borderJoinType: event.target.value }); }}>
{borderOption.lineJoinStyleList.map(({ name, value }) => {
return <option value={value} key={name}>{name}</option>
})}
</select>
<input type="button" onClick={() => { updateShapeBorderStyle('joinType', borderOption.borderJoinType) }} value="Set" />
</div>
}
</div >);
}
function getEnumList(enumObject) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app{
width: 100%;
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

You can customize the properties of autoShapes using the Shape API:
text: Gets or sets the text of the shape.
style: Gets or sets the style of the shape.
You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
</gc-spread-sheets>
<shape-panel @updateShapeBorderStyle="updateShapeBorderStyle" :showBorderPanelRef="showBorderPanelRef">
</shape-panel>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref, createApp } from "vue";
import "@mescius/spread-sheets-vue";
import '@mescius/spread-sheets-shapes';
const spreadRef = ref(null);
const showBorderPanelRef = ref(false);
const updateShapeBorderStyle = (action, value) => {
let sheet = spreadRef.value.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
if (activeShape) {
activeShape.forEach(function (shape) {
let shapeStyle = shape.style();
shapeStyle.line[action] = value;
shape.style(shapeStyle);
});
sheet.repaint();
}
}
const bindSpreadEvent = () => {
spreadRef.value.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function () {
let sheet = spreadRef.value.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function (sp) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
setBorderPropVisibility(true);
} else {
setBorderPropVisibility(false);
}
})
}
const setBorderPropVisibility = (isShow) => {
showBorderPanelRef.value = isShow;
}
const initSpread = (spread) => {
spreadRef.value = spread;
let oval = spread.getActiveSheet().shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 40, 20, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#FFFFFF";
oval.style(ovalStyle);
var rectangle = spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 230, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#FFFFFF";
rectangle.style(rectangleStyle);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 250, 20, 400, 150);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 250, 250, 400, 350);
bindSpreadEvent();
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<template>
<div class="options-container">
<div class="option-row">
Try selecting a shape and change the border properties to see the effect:
</div>
<div id="divideLine" class="divide-line"></div>
<div v-show="props.showBorderPanelRef" class="option-row">
<label>Border Color: </label>
<input v-model="borderColorRef" type="color" />
<input type="button" @click="_handleShapeBorderAction('color', borderColorRef)" value="Set" />
<label>Border Transparency: </label>
<input v-model="borderTransparencyRef" type="text" value="0.5" />
<input type="button" @click="_handleShapeBorderAction('transparency', borderTransparencyRef)" value="Set" />
<label>Border Width: </label>
<input v-model="borderWidthRef" type="number" />
<input type="button" @click="_handleShapeBorderAction('width', borderWidthRef)" value="Set" />
<label>Border Line Style: </label>
<select v-model="borderLineStyleRef">
<option v-bind:value="item.value" v-for="item in lineDashStyleListRef" :key="item.name">{{ item.name }}</option>
</select>
<input type="button" @click="_handleShapeBorderAction('lineStyle', borderLineStyleRef)" value="Set" />
<label>Border Cap Line Style: </label>
<select v-model.number="borderCapTypeRef">
<option v-bind:value="item.value" v-for="item in lineCapStyleListRef" :key="item.name">{{ item.name }}</option>
</select>
<input type="button" @click="_handleShapeBorderAction('capType', borderCapTypeRef)" value="Set" />
<label>Border Join Line Style: </label>
<select v-model="borderJoinTypeRef">
<option v-bind:value="item.value" v-for="item in lineJoinStyleListRef" :key="item.name">{{ item.name }}</option>
</select>
<input type="button" @click="_handleShapeBorderAction('joinType', borderJoinTypeRef)" value="Set" />
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import { defineEmits, ref } from 'vue';
let lineCapStyle = {
flat: 2,
square: 1,
round: 0
};
let lineJoinStyle = {
round: 0,
miter: 1,
bevel: 2
};
let lineDashStyle = {
solid: 0,
squareDot: 1,
dash: 2,
longDash: 3,
dashDot: 4,
longDashDot: 5,
longDashDotDot: 6,
sysDash: 7,
sysDot: 8,
sysDashDot: 9,
dashDotDot: 10
};
const borderColorRef = ref("#00A2E8");
const borderTransparencyRef = ref(0.5);
const borderWidthRef = ref(1);
const borderLineStyleRef = ref(2);
const borderCapTypeRef = ref(2);
const borderJoinTypeRef = ref(2);
const lineCapStyleListRef = ref(getEnumList(lineCapStyle));
const lineJoinStyleListRef = ref(getEnumList(lineJoinStyle));
const lineDashStyleListRef = ref(getEnumList(lineDashStyle));
const props = defineProps({ showBorderPanelRef: Boolean });
const emits = defineEmits(['updateShapeBorderStyle']);
const _handleShapeBorderAction = (action, value) => {
emits("updateShapeBorderStyle", action, value);
}
function getEnumList(enumObject) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(name, 10)) == name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function (a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
</script>
<style scoped></style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/inventory-tracker.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

You can customize the properties of autoShapes using the Shape API:
text: Gets or sets the text of the shape.
style: Gets or sets the style of the shape.
You can customize the properties of connectorShapes using the ConnectorShape API:
style: Gets or sets the style of the connector shape.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes"
import './styles.css';
function getEnumList(enumObject: object) {
let names = [];
for (var name in enumObject) {
if (name === "none" || (parseInt(<any>name, 10)) == <any>name) {
continue;
}
names.push({
name: name,
value: enumObject[name]
});
}
names.sort(function(a, b) {
return a.name > b.name ? 1 : -1
});
return names;
}
const lineCapStyle = {
flat: 2,
square: 1,
round: 0
};
const lineJoinStyle = {
round: 0,
miter: 1,
bevel: 2
};
const lineDashStyle = {
solid: 0,
squareDot: 1,
dash: 2,
longDash: 3,
dashDot: 4,
longDashDot: 5,
longDashDotDot: 6,
sysDash: 7,
sysDot: 8,
sysDashDot: 9,
dashDotDot: 10
};
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
showBorderPanel = false;
borderColor = "#00A2E8";
borderTransparency = 0.5;
borderWidth = 1;
borderLineStyle = 2;
borderCapType = 2;
borderJoinType = 2;
lineCapStyleList = getEnumList(lineCapStyle);
lineJoinStyleList = getEnumList(lineJoinStyle);
lineDashStyleList = getEnumList(lineDashStyle);
initSpread($event: any) {
let spread = this.spread = $event.spread;
let oval = spread.getActiveSheet().shapes.add("oval", GC.Spread.Sheets.Shapes.AutoShapeType.oval, 40, 20, 150, 150);
let ovalStyle = oval.style();
ovalStyle.fill.color = "#FFFFFF";
oval.style(ovalStyle);
var rectangle = spread.getActiveSheet().shapes.add("rectangle", GC.Spread.Sheets.Shapes.AutoShapeType.rectangle, 40, 230, 150, 150);
let rectangleStyle = rectangle.style();
rectangleStyle.fill.color = "#FFFFFF";
rectangle.style(rectangleStyle);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.straight, 250, 20, 400, 150);
spread.getActiveSheet().shapes.addConnector("line", GC.Spread.Sheets.Shapes.ConnectorType.elbow, 250, 250, 400, 350);
this.bindSpreadEvent();
}
bindSpreadEvent() {
let spread = this.spread,
self = this;
spread.bind(GC.Spread.Sheets.Events.ShapeSelectionChanged, function() {
let sheet = spread.getActiveSheet();
var selectedShape = sheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
var isShapeSelected = false,
isConnectorSelected = false;
if (selectedShape.length > 0) {
selectedShape.forEach((shape: GC.Spread.Sheets.Shapes.ShapeBase) => {
if (!isShapeSelected && shape instanceof GC.Spread.Sheets.Shapes.Shape) {
isShapeSelected = true;
} else if (!isConnectorSelected && shape instanceof GC.Spread.Sheets.Shapes.ConnectorShape) {
isConnectorSelected = true;
}
});
self.setBorderPropVisibility(true);
} else {
self.setBorderPropVisibility(false);
}
})
}
setBorderPropVisibility(isShow: boolean) {
this.showBorderPanel = isShow;
}
updateShapeBorderStyle(action: string, value: any) {
let sheet = this.spread.getActiveSheet();
let activeShape = sheet.shapes.all().filter(function(sp: GC.Spread.Sheets.Shapes.ShapeBase) {
return sp.isSelected();
});
if (activeShape.length > 0) {
activeShape.forEach(function(shape: GC.Spread.Sheets.Shapes.ShapeBase) {
let shapeStyle = shape.style();
shapeStyle.line[action] = value;
shape.style(shapeStyle);
});
sheet.repaint();
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
Try selecting a shape and change the border properties to see the effect:
</div>
<div id="divideLine" class="divide-line"></div>
<div *ngIf="showBorderPanel" class="option-row">
<label>Border Color: </label>
<input [(ngModel)]="borderColor" type="color" />
<input type="button" (click)="updateShapeBorderStyle('color', borderColor)" value="Set" />
<label>Border Transparency: </label>
<input [(ngModel)]="borderTransparency" type="text" value="0.5" />
<input type="button" (click)="updateShapeBorderStyle('transparency', borderTransparency)" value="Set" />
<label>Border Width: </label>
<input [(ngModel)]="borderWidth" type="number" />
<input type="button" (click)="updateShapeBorderStyle('width', borderWidth)" value="Set" />
<label>Border Line Style: </label>
<select [(ngModel)]="borderLineStyle">
<option *ngFor="let item of lineDashStyleList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateShapeBorderStyle('lineStyle', borderLineStyle)" value="Set" />
<label>Border Cap Line Style: </label>
<select [(ngModel)]="borderCapType">
<option *ngFor="let item of lineCapStyleList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateShapeBorderStyle('capType', borderCapType)" value="Set" />
<label>Border Join Line Style: </label>
<select [(ngModel)]="borderJoinType">
<option *ngFor="let item of lineJoinStyleList" [value]="item.value|number">
{{item.name}}
</option>
</select>
<input type="button" (click)="updateShapeBorderStyle('joinType', borderJoinType)" value="Set" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding-left: 5px;
}
.divide-line {
width: 100%;
height: 1px;
background: #cbcbcb;
margin-top: 10px;
margin-bottom: 3px;
}
.title {
text-align: center;
font-weight: bold;
}
label {
display: block;
margin-top: 15px;
margin-bottom: 5px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
input {
width: 160px;
margin-left: 10px;
display: inline;
}
input[type=button] {
width: 50px;
margin-left: 1px;
}
select {
width: 160px;
margin-left: 10px;
display: inline;
}
textarea {
width: 160px;
margin-left: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);